<template lang="html">
  <v-dialog
      v-model="dialog"
      width="500"
    >
    <template v-slot:activator="{ on, attrs }">
      <v-btn
        color="red lighten-2"
        dark
        v-bind="attrs"
        v-on="on"
      >
        Vote
      </v-btn>
    </template>

    <v-card
      class="mx-auto my-12"
      max-width="400"
      >
      <v-card-title>Vote</v-card-title>

      <v-card-subtitle>Voting power {{ votingPower }}</v-card-subtitle>
        <v-card-text>
          <v-row align="center">
           <v-col
             class="d-flex"
             cols="12"
           >
             <v-radio-group v-model="votingOption">
               <v-radio
                 v-for="option in votingOptions"
                 :key="option"
                 :label="option"
                 :value="option"
               ></v-radio>
             </v-radio-group>
           </v-col>
        </v-row>
        <v-row align="center">
          <v-col
            class="d-flex"
            cols="12"
          >
            <v-text-field
              v-model="votingReason"
              hint="Additional reason for your vote"
              label="Reason"
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row
          align="center"
          justify="space-around"
        >
          <v-btn @click="submit" color="primary">
          Submit
          </v-btn>
        </v-row>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
import { getGovernor } from "@/helpers/contracts/governance";
import { getToken, getTokenMetadata, decimalize } from "@/helpers/contracts/token";
import { VoteTypeIds, VoteType } from "@/helpers/constants";

export default {
  name: "Active",
  props: [
    "proposalId"
  ],
  data() {
    return {
      votingOption: null,
      votingReason: null,
      votingOptions: [VoteType.For, VoteType.Against, VoteType.Abstain],
      votingPower: 0
    }
  },
  async created() {
    this.votingPower = await this.getVotingPower();
  },
  methods: {
    async getVotingPower() {
      const token = await getToken();
      const tokenMetadata = await getTokenMetadata();

      return decimalize((await token.getVotes(this.$store.state.accounts[0])).toString(), (await tokenMetadata.decimals()).toString(), 4);
    },
    async submit() {
      const votingOptionId = Object.values(VoteTypeIds).indexOf(this.votingOption);

      const provider = this.$store.state.provider;
      const governor = getGovernor();

      try {
        if (this.votingReason) {
          await governor.connect(provider.getSigner(this.$store.state.accounts[0])).castVoteWithReason(this.proposalId, votingOptionId, this.votingReason);
        } else {
          await governor.connect(provider.getSigner(this.$store.state.accounts[0])).castVote(this.proposalId, votingOptionId);
        }
      } catch (err) {
        console.error(err);
      }
    }
  }
}
</script>
